﻿using System;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Net;
using System.IO;
using System.Xml;
using System.Drawing;


namespace  GPStoGoogleMapDesktop
{
    public partial class TestForm : Form
    {     

        readonly static string _bingCacheDirectory = @"C:\bing cache\cache\";
        FileBitmapTileCache _cache = new FileBitmapTileCache(_bingCacheDirectory);

        


        public TestForm()
        {
            InitializeComponent();           
        }

        void source_SendingRequest(object sender, SendingRequestBingMapsLayerEventArgs e)
        {
            //e.RequestUri = new Uri(@"RequsetStringForWMS1.3.0");

            string temp = e.RequestUri;

            
            //TODO: Get URI -> get image -> compare image to cached image -> if they are different clear cache.
            
        }

        private void TestForm_Load(object sender, EventArgs e)
        {
            //fileBitmapTileCache.ClearCache();
            //fileBitmapPreviewTileCache.ClearCache();


            //winformsMap1.ThreadingMode = MapThreadingMode.SingleThreaded;
            
            winformsMap1.MapUnit = GeographyUnit.Meter;
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 198, 255, 255));
                        
            BingLayer bingLayer = new BingLayer("Ai7suMEtJnFbj-QTaVH6TwJ29nYOjN6udUzR42VNna_QTMURVOYZulMni6U48qJT", BingMapsMapType.Aerial);     
            bingLayer.LogoMode = BingMapsLogoMode.NoLogo;
            bingLayer.CacheDirectory = _bingCacheDirectory;
            bingLayer.DrawingExceptionMode = DrawingExceptionMode.ThrowException;

            bingLayer.SendingRequest += source_SendingRequest;            
          
                        
            MyLayerOverlay bingLayerOverlay = new MyLayerOverlay();
            bingLayerOverlay.Layers.Add(bingLayer);
            bingLayerOverlay.DrawingExceptionMode = DrawingExceptionMode.ThrowException;
            
            winformsMap1.Overlays.Add(bingLayerOverlay);

            ////BingMapsOverlay bingOverlay = new BingMapsOverlay("Ai7suMEtJnFbj-QTaVH6TwJ29nYOjN6udUzR42VNna_QTMURVOYZulMni6U48qJT", BingMapsMapType.Aerial, @"C:\bing cache\", BingMapsLogoMode.NoLogo);
            //BingOverlay bingOverlay = new BingOverlay("Ai7suMEtJnFbj-QTaVH6TwJ29nYOjN6udUzR42VNna_QTMURVOYZulMni6U48qJT", BingMapsMapType.Aerial);
            //bingOverlay.LogoMode = BingMapsLogoMode.NoLogo;
            //bingOverlay.TileCache = fileBitmapTileCache;
            ////bingOverlay.PreviewTileCache = fileBitmapPreviewTileCache;
            //bingOverlay.IsBase = true;
            //bingOverlay.DrawingExceptionMode = DrawingExceptionMode.ThrowException;
            
            //winformsMap1.Overlays.Add(bingOverlay);

            //GoogleMapsOverlay googleOverlay = new GoogleMapsOverlay(); //(@"Insert your key here!", @"C:\GoogleCache");
            //googleOverlay.MapType = GoogleMapsMapType.Terrain;
            //winformsMap1.Overlays.Add(googleOverlay);

            // This sets the zoom levels to map to Googles.  We next make sure we snap to the zoomlevels
            //winformsMap1.ZoomLevelSet = new GoogleMapZoomLevelSet();            
            winformsMap1.ZoomLevelSet = new BingMapsZoomLevelSet();

            InMemoryFeatureLayer pointLayer = new InMemoryFeatureLayer();
            pointLayer.Open();
            pointLayer.Columns.Add(new FeatureSourceColumn("Text"));
            pointLayer.Close();

            //Sets the projection parameters to go from Geodetic (EPSG 4326) or decimal degrees to Google Map projection (Spherical Mercator).
            Proj4Projection proj4 = new Proj4Projection();
            proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
            proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
            //Applies the projection to the InMemoryFeatureLayer so that the point in decimal degrees (Longitude/Latitude) can be 
            //match the projection of Google Map.
            pointLayer.FeatureSource.Projection = proj4;

            //Values in Longitude and Latitude.
            double Longitude = -93.789018;
            double Latitude = 41.601151;

            //Creates the feature made of a PointShape with the Longitude and Latitude values.
            Feature GPSFeature = new Feature(new PointShape(Longitude, Latitude));

            //Format the Longitude and Latitude into a nice string as Degrees Minutes and Seconds
            string LongLat = DecimalDegreesHelper.GetDegreesMinutesSecondsStringFromDecimalDegreePoint(GPSFeature);

            //Sets the InMemoryFeatureLayer to have it displayed with Square symbol and with text.
            GPSFeature.ColumnValues.Add("Text", "Boston's    " + LongLat);
            pointLayer.InternalFeatures.Add(GPSFeature);

            pointLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Square, GeoColor.StandardColors.Red, GeoColor.StandardColors.Black, 2, 12);
            pointLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("Text", "Arial", 12, DrawingFontStyles.Bold, GeoColor.StandardColors.Black, GeoColor.StandardColors.White, 3, -10, 10);
            pointLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay pointOverlay = new LayerOverlay();
            pointOverlay.Layers.Add("PointLayer", pointLayer);           


            ShapeFileFeatureLayer polkShapeLayer = new ShapeFileFeatureLayer(@"C:\bing cache\IA\Polk\IA153ctycu.shp");
            polkShapeLayer.ZoomLevelSet = new BingMapsZoomLevelSet();
            polkShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.StandardColors.Red, GeoColor.StandardColors.Black, 9);
            polkShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.CreateMaskTextStyle("NAME", new GeoFont("Arial", 10, DrawingFontStyles.Bold),
            new GeoSolidBrush(GeoColor.StandardColors.Black), new AreaStyle(new GeoSolidBrush(GeoColor.StandardColors.LightGoldenrodYellow)), 13, 0);
            polkShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(50, GeoColor.SimpleColors.Yellow), GeoColor.StandardColors.Yellow, 1, LineDashStyle.Solid);
            polkShapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            //Sets the projection to the shapefile layer.
            polkShapeLayer.FeatureSource.Projection = proj4;

            ShapeFileFeatureLayer dallasShapeLayer = new ShapeFileFeatureLayer(@"C:\bing cache\IA\Dallas\IA049ctycu.shp");
            dallasShapeLayer.ZoomLevelSet = new BingMapsZoomLevelSet();
            dallasShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.StandardColors.Red, GeoColor.StandardColors.Black, 9);
            dallasShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.CreateMaskTextStyle("NAME", new GeoFont("Arial", 10, DrawingFontStyles.Bold),
            new GeoSolidBrush(GeoColor.StandardColors.Black), new AreaStyle(new GeoSolidBrush(GeoColor.StandardColors.LightGoldenrodYellow)), 13, 0);
            dallasShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(50, GeoColor.SimpleColors.Yellow), GeoColor.StandardColors.Yellow, 1, LineDashStyle.Solid);
            dallasShapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            //Sets the projection to the shapefile layer.
            dallasShapeLayer.FeatureSource.Projection = proj4;

            ShapeFileFeatureLayer siouxShapeLayer = new ShapeFileFeatureLayer(@"C:\bing cache\IA\Sioux\IA167ctycu.shp");
            siouxShapeLayer.ZoomLevelSet = new BingMapsZoomLevelSet();
            siouxShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.StandardColors.Red, GeoColor.StandardColors.Black, 9);
            siouxShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.CreateMaskTextStyle("NAME", new GeoFont("Arial", 10, DrawingFontStyles.Bold), new GeoSolidBrush(GeoColor.StandardColors.Black), new AreaStyle(new GeoSolidBrush(GeoColor.StandardColors.LightGoldenrodYellow)), 13, 0);
            siouxShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(50, GeoColor.SimpleColors.Yellow), GeoColor.StandardColors.Yellow, 1, LineDashStyle.Solid);
            siouxShapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            //Sets the projection to the shapefile layer.
            siouxShapeLayer.FeatureSource.Projection = proj4;

            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.Layers.Add("polkShapeLayer", polkShapeLayer);
            staticOverlay.Layers.Add("dallasShapeLayer", dallasShapeLayer);
            staticOverlay.Layers.Add("siouxShapeLayer", siouxShapeLayer);
            
            winformsMap1.Overlays.Add(staticOverlay);
            winformsMap1.Overlays.Add("PointOverlay", pointOverlay);

            //Add a field
            string wkt = "POLYGON ((-96.12738699548338 43.142020002252984,-96.12734101269064 43.140485004911156,-96.1273250121209 43.13940499772093,-96.12738000292126 43.1391209998834,-96.1273690099484 43.13909099106735,-96.12734799484141 43.13907800302802,-96.12708100843477 43.13905600754453,-96.12320100879145 43.139091009956566,-96.11819499337054 43.13915499539665,-96.11781301052363 43.139154998857016,-96.11751400491413 43.13914299913993,-96.11746900842702 43.139157008518254,-96.1174560022105 43.1391910022309,-96.11752299249069 43.13945699503034,-96.11753398930966 43.14031700455982,-96.11759700156537 43.14237699280417,-96.11762101254398 43.142591992023284,-96.11771500320117 43.1426540083656,-96.11786698696591 43.142692997497306,-96.1179780072292 43.14269900168033,-96.11898800235541 43.1427119984208,-96.1204469954831 43.142701000390275,-96.12147099570674 43.142683004871046,-96.12255101042884 43.14267999888865,-96.12364999619784 43.142658994358975,-96.1273550059777 43.14261500269588,-96.12740801104927 43.14260000142729,-96.12742201291472 43.142569007537006,-96.12738998854448 43.142323998227354,-96.12738801242217 43.14207699854265,-96.12738699548338 43.142020002252984))";

            LayerOverlay fieldsOverlay = new LayerOverlay();
            InMemoryFeatureLayer fieldLayer = new InMemoryFeatureLayer();
            fieldLayer.ZoomLevelSet = new BingMapsZoomLevelSet();
            fieldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(50, GeoColor.SimpleColors.Red), GeoColor.StandardColors.Red, 1, LineDashStyle.Solid);
            fieldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            fieldLayer.FeatureSource.Projection = proj4;
           
            Feature field = new PolygonShape(wkt).GetFeature();
            field.ColumnValues.Add("FieldName", "TestField");

            fieldLayer.Open();
            List<string> columns = new List<string>(field.ColumnValues.Keys);

            foreach(string columnName in columns)
                fieldLayer.Columns.Add(new FeatureSourceColumn(columnName));

            fieldLayer.InternalFeatures.Add(field);
                       
            fieldLayer.Close();


            fieldsOverlay.Layers.Add(fieldLayer);
            winformsMap1.Overlays.Add(fieldsOverlay);


            BingMapsLayer bingMapLayer = new BingMapsLayer("Ai7suMEtJnFbj-QTaVH6TwJ29nYOjN6udUzR42VNna_QTMURVOYZulMni6U48qJT", BingMapsMapType.Road);
            bingMapLayer.LogoMode = BingMapsLogoMode.NoLogo;
            bingMapLayer.CacheDirectory = @"C:\bing cache\cache\minimap\";
            
            MiniMapAdornmentLayer miniMapLayer = new MiniMapAdornmentLayer();
            miniMapLayer.Location = AdornmentLocation.LowerLeft;
            miniMapLayer.Layers.Add(new BackgroundLayer(winformsMap1.BackgroundOverlay.BackgroundBrush));
            miniMapLayer.Layers.Add(bingMapLayer);

            winformsMap1.AdornmentOverlay.Layers.Add(miniMapLayer);

            


            ////zoom to field
            //fieldLayer.Open();
            //winformsMap1.CurrentExtent = fieldLayer.GetBoundingBox();
            //fieldLayer.Close();
            


            //polkShapeLayer.Open();
            //winformsMap1.CurrentExtent = polkShapeLayer.GetBoundingBox();
            //polkShapeLayer.Close();

            siouxShapeLayer.Open();
            winformsMap1.CurrentExtent = siouxShapeLayer.GetBoundingBox();
            siouxShapeLayer.Close();



            ////Sets the extend of the map based on the GPS point.
            //proj4.Open();
            //Vertex projVertex = proj4.ConvertToExternalProjection(Longitude, Latitude);
            //proj4.Close();

            //double extendWidth = 2300;
            //double extendHeight = 1200;

            //winformsMap1.CurrentExtent = new RectangleShape((projVertex.X - extendWidth), (projVertex.Y + extendHeight),
            //    (projVertex.X + extendWidth), (projVertex.Y - extendHeight));


            winformsMap1.ZoomLevelSnapping = ZoomLevelSnappingMode.SnapUp;
                                  

            winformsMap1.Refresh();

        }

      
        private void winformsMap1_MouseMove(object sender, MouseEventArgs e)
        {
            //Displays the X and Y in screen coordinates.
            statusStrip1.Items["toolStripStatusLabelScreen"].Text = "X:" + e.X + " Y:" + e.Y;
        
            //Gets the PointShape in world coordinates from screen coordinates.
            PointShape pointShape = ExtentHelper.ToWorldCoordinate(winformsMap1.CurrentExtent, new ScreenPointF(e.X, e.Y), winformsMap1.Width, winformsMap1.Height);

            //Displays world coordinates.
            statusStrip1.Items["toolStripStatusLabelWorld"].Text = "(world) X:" + Math.Round(pointShape.X, 4) + " Y:" + Math.Round(pointShape.Y, 4);
                     
        }
        
        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnClearCache_Click(object sender, EventArgs e)
        {
            System.IO.Directory.Delete(_bingCacheDirectory, true);            
            _cache.ClearCache();            
        }

        private void btnCheckBing_Click(object sender, EventArgs e)
        {
            string vintageStart;
            string vintageEnd;

            try
            {
                XmlTextReader reader = new XmlTextReader(@"http://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial/43.198168406832,-96.5052795410156?zl=10&mv=v1&o=xml&key=Ai7suMEtJnFbj-QTaVH6TwJ29nYOjN6udUzR42VNna_QTMURVOYZulMni6U48qJT");
                string sName = "";
                while (reader.Read())
                {
                    switch (reader.NodeType)
                    {
                        case XmlNodeType.Element:
                            sName = reader.Name;
                            break;
                        case XmlNodeType.Text:
                            switch (sName)
                            {
                                case "VintageStart":
                                    vintageStart = reader.Value;
                                    break;
                                case "VintageEnd":
                                    vintageEnd = reader.Value;
                                    break;
                            }
                            break;
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }


            //BitmapTile tile = _cache.GetTile(winformsMap1.CurrentExtent.GetBoundingBox());
            RowColumnRange rowColumnRange = _cache.TileMatrix.GetIntersectingRowColumnRange(winformsMap1.CurrentExtent);

          

            //for (long row = rowColumnRange.MinRowIndex; row <= rowColumnRange.MaxRowIndex; row++)
            //{
            //    for (long column = rowColumnRange.MinColumnIndex; column <= rowColumnRange.MaxColumnIndex; column++)
            //    {
            //        RectangleShape tileExtent = _cache.TileMatrix.GetCell(row, column).BoundingBox;

            //    }
                



            //}


            Double zoomLevel = 10;
            
            //Sets the projection parameters to go from Geodetic (EPSG 4326) or decimal degrees to Google Map projection (Spherical Mercator).
            Proj4Projection proj4 = new Proj4Projection();
            proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
            proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
            //Applies the projection to the InMemoryFeatureLayer so that the point in decimal degrees (Longitude/Latitude) can be 
            //match the projection of Google Map.
            
            int maxPixelInCurrentZoomLevel = (int)Math.Pow(2, zoomLevel) * 256 - 1;

            PointShape ddCenter = winformsMap1.CurrentExtent.GetCenterPoint();

            proj4.Open();
            PointShape projectedCenter = proj4.ConvertToExternalProjection(ddCenter) as PointShape;
            proj4.Close();


            long row = _cache.TileMatrix.GetRowIndex(projectedCenter);
            long column = _cache.TileMatrix.GetColumnIndex(projectedCenter);

            int pixelCenterX;
            int pixelCenterY;

            LatLongToPixelXY(ddCenter.Y, ddCenter.X, Convert.ToInt32(zoomLevel), out pixelCenterX, out pixelCenterY);

            int minX = (int)Math.Ceiling(pixelCenterX - winformsMap1.Width * 0.5);
            int minY = (int)Math.Ceiling(pixelCenterY - winformsMap1.Height * 0.5);
            int maxX = (int)Math.Floor(pixelCenterX + winformsMap1.Width * 0.5);
            int maxY = (int)Math.Floor(pixelCenterY + winformsMap1.Height * 0.5);

            if (minX < 0)
            {
                minX = 0;
            }
            if (minY < 0)
            {
                minY = 0;
            }
            if (maxX > maxPixelInCurrentZoomLevel)
            {
                maxX = maxPixelInCurrentZoomLevel;
            }
            if (maxY > maxPixelInCurrentZoomLevel)
            {
                maxY = maxPixelInCurrentZoomLevel;
            }

            double TileWidth = 256;
            double TileHeight = 256;

            int startTileColumn = (int)Math.Floor(minX / (double)TileWidth);
            int endTileColumn = (int)Math.Ceiling(maxX / (double)TileWidth);
            int startTileRow = (int)Math.Floor(minY / (double)TileHeight);
            int endTileRow = (int)Math.Ceiling(maxY / (double)TileHeight);

            




















            
            




        }

        

        public static void LatLongToPixelXY(double latitude, double longitude, int levelOfDetail, out int pixelX, out int pixelY)
        {
            double sinLatitude = Math.Sin(latitude * Math.PI / 180);
            double x = (longitude + 180) / 360;
            double y = 0.5 - Math.Log((1 + sinLatitude) / (1 - sinLatitude)) / (4 * Math.PI);
            
            uint mapSize = MapSize(levelOfDetail);
            pixelX = (int)(x * mapSize + 0.5);
            pixelY = (int)(y * mapSize + 0.5);
        }

        private static uint MapSize(int levelOfDetail)
        {
            return (uint)256 << levelOfDetail;
        }

        private void btnPreCache_Click(object sender, EventArgs e)
        {
            BingLayer bingLayer = new BingLayer("Ai7suMEtJnFbj-QTaVH6TwJ29nYOjN6udUzR42VNna_QTMURVOYZulMni6U48qJT", BingMapsMapType.Aerial);
            bingLayer.LogoMode = BingMapsLogoMode.NoLogo;
            bingLayer.CacheDirectory = _bingCacheDirectory;
            bingLayer.DrawingExceptionMode = DrawingExceptionMode.ThrowException;

            Collection<BingLayer> layers = new Collection<BingLayer>();
            layers.Add(bingLayer);


            RectangleShape restrictedExtent = new RectangleShape(-180, 90, 180, -90);


            GenerateCacheFiles(layers, winformsMap1.ZoomLevelSet.ZoomLevel01.Scale, restrictedExtent, GeographyUnit.DecimalDegree, _bingCacheDirectory);
            GenerateCacheFiles(layers, winformsMap1.ZoomLevelSet.ZoomLevel02.Scale, restrictedExtent, GeographyUnit.DecimalDegree, _bingCacheDirectory);
            GenerateCacheFiles(layers, winformsMap1.ZoomLevelSet.ZoomLevel03.Scale, restrictedExtent, GeographyUnit.DecimalDegree, _bingCacheDirectory);

        }

        private static void GenerateCacheFiles(IEnumerable<BingLayer> layers, double scale, RectangleShape restrictedExtent, GeographyUnit mapUnit, string cacheDirectory)
        {
            // create a MapSuite default tile matrix object.
            MapSuiteTileMatrix matrix = new MapSuiteTileMatrix(scale, 256, 256, mapUnit);

            // get cells in the specified extent.
            Collection<TileMatrixCell> cells = matrix.GetIntersectingCells(restrictedExtent);

            // create a tile cache object with the cache directory and cache id.
            FileBitmapTileCache tileCache = new FileBitmapTileCache(cacheDirectory);

            foreach (TileMatrixCell cell in cells)
            {
                // create a bitmap whoes size equals to the tile size.
                using (Bitmap bitmap = new Bitmap(256, 256))
                {
                    // create a GeoCanvas which for drawing the passed layers.
                    GdiPlusGeoCanvas geoCanvas = new GdiPlusGeoCanvas();
                    geoCanvas.BeginDrawing(bitmap, cell.BoundingBox, mapUnit);
                    foreach (Layer layer in layers)
                    {
                        lock (layer)
                        {
                            if (!layer.IsOpen) { layer.Open(); }
                            layer.Draw(geoCanvas, new Collection<SimpleCandidate>());
                        }
                    }

                    // you can commend this line out because it's just for mark a cache label in order to see if it works with our samples.
                    geoCanvas.DrawText("Cache", new GeoFont("Arial", 12), new GeoSolidBrush(GeoColor.SimpleColors.Black), new Collection<ScreenPointF>() { new ScreenPointF(128f, 128f) }, DrawingLevel.LabelLevel);
                    geoCanvas.EndDrawing();

                    // create tile object to maintain current tile information.
                    BitmapTile tile = new BitmapTile(bitmap, cell.BoundingBox, scale);

                    // save tile.
                    tileCache.SaveTile(tile);
                }
            }
        }
    }
}
